#include "imagepak.h"

int main(int argc, char* argv[])
{
	IMG Img;
	// 
	Img=OpenGraphFile("Img1_1.bmp");

	IMG Img8=Img24To8(Img);

	//  
	RECT Rect;
	Rect.left=0;
	Rect.top=0;
	Rect.bottom=Img8.Height-1;
	Rect.right=Img8.Width-1;

	ThresholdImage(Img8,128,Rect);

	// 

	AllocationBordersRect(Img8,Rect,ALLOCATE_WHITE);

	// 
	CONTOUR Contour;
	Contour.Find(Img8,Rect,128,CONTOUR_AUTO_INOUT);		
	int all=Contour.ReturnAllContours();

	int i,j,k;
	if (all>0)
	{		
		Contour.ReturnMaxLevel(i,j,k);
		//           
		//, ..    
		RECT Rect1=Contour.ReturnRectContour(j);
		//   
		DrawRect(Img,Rect1,0,255,0);
		//  
		int x=7,y=7;
		GRID Grid(x,y);//  7  7
		FOUR_FIG_Pd pp;// 
		pp.p[0].x=Rect1.left;
		pp.p[0].y=Rect1.top;
		pp.p[1].x=Rect1.right;
		pp.p[1].y=Rect1.bottom;
		pp.p[2].x=Rect1.right;
		pp.p[2].y=Rect1.top;
		pp.p[3].x=Rect1.left;
		pp.p[3].y=Rect1.bottom;
		Grid.CreateGrid(pp);

		bool array_data[1000];
		if (Grid.RecogCells(Img8
#ifdef ON_DEBUG
	,Img
#endif
						)==0)
			Grid.ReturnGrid(0.5,array_data[0]);
		FILE *f;
		char buf[20];
		f=fopen("out.log","w");
		for(i=0;i<y;i++)
		{
			for(j=0;j<x;j++)
			{
				sprintf(buf,"%d",array_data[j+i*x]);
				fputs(buf,f);
			}
			fputs("\n",f);
		}
		fclose(f);

	}

#ifdef ON_DEBUG
	SaveDF("Img_out.bmp",Img);
#endif

	// 

	DeleteImg(Img);
	DeleteImg(Img8);

	return 0;
}
