/*	______________________________________________________________________

	comparison.cpp  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	 
	______________________________________________________________________
*/

#include "comparison.h"

/*
  24- .   Img1.  `   
0 -  
*/
int AllocationUnknownPixels(IMG Img1,IMG Img2,BYTE flags)
{
	if (Img1.Width<=0 || Img1.Height<=0 || Img2.Width<=0 ||  Img2.Height<=0) return 1;	
	if (Img1.format!=0 || Img2.format!=0) return 2;
	if (Img1.Width!=Img2.Width) return 3;
	if (Img1.Height!=Img2.Height) return 3;
	int i,j;
	for(i=0;i<Img1.Height;i++)
		for(j=0;j<Img1.Width;j++)
		{
			if (Img1.bytes[(i*Img1.Width_1)+j*3]==Img2.bytes[(i*Img2.Width_1)+j*3] &&
				Img1.bytes[(i*Img1.Width_1)+j*3+1]==Img2.bytes[(i*Img2.Width_1)+j*3+1] &&
				Img1.bytes[(i*Img1.Width_1)+j*3+2]==Img2.bytes[(i*Img2.Width_1)+j*3+2])
			{
				
				Img1.bytes[(i*Img1.Width_1)+j*3]=0;
				Img1.bytes[(i*Img1.Width_1)+j*3+1]=0;
				Img1.bytes[(i*Img1.Width_1)+j*3+2]=0;
				
			}
			else
			{
				if ((AUP_ONE_COLOR&flags)==AUP_ONE_COLOR) 
				{
					Img1.bytes[(i*Img1.Width_1)+j*3]=255;
					Img1.bytes[(i*Img1.Width_1)+j*3+1]=255;
					Img1.bytes[(i*Img1.Width_1)+j*3+2]=255;
				}
			}
		}
	return 0;
}

//    AUP_ONE_COLOR 24  
C_POINTd CentreWeights(IMG Img)
{
	C_POINTd p;

	p.x=0;p.y=0;

	long i,j,k=0;
	for(i=0;i<Img.Height;i++)
		for(j=0;j<Img.Width;j++)
			if (Img.bytes[(i*Img.Width_1)+j*3]==255)
			{
				k++;
				p.x+=j;
				p.y+=i;
			}
	p.x/=(double)k;
	p.y/=(double)k;

	return p;
}