/*	______________________________________________________________________

	grid.cpp  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	   -   	
	______________________________________________________________________
*/

#include "grid.h"

//      1 x  y
GRID::GRID(int x,int y)
{
	l=new F_LINE[5+(x-1)+(y-1)];
	cells=new double[100+(x)*(y)];
	y_size=y;
	x_size=x;	
}

GRID::~GRID()
{
	if (l!=NULL)
		delete l;
	if (cells!=NULL)
		delete cells;

}


//,int*pointer -     4 ,      
int GRID::CreateGrid(FOUR_FIG_Pd pp,F_LINE f1,F_LINE f2,F_LINE f3,F_LINE f4,int*pointer)
{
	main_p=pp;
	/*main_p.p[0].x=pp.p[0].x;
	main_p.p[1]=pp.p[1];
	main_p.p[2]=pp.p[2];
	main_p.p[3]=pp.p[3];*/
	main_l.l[0]=MakeLine(main_p.p[0],main_p.p[2]);
	main_l.l[1]=MakeLine(main_p.p[2],main_p.p[1]);
	main_l.l[2]=MakeLine(main_p.p[1],main_p.p[3]);
	main_l.l[3]=MakeLine(main_p.p[3],main_p.p[0]);

	int* pointer_;
	int pointer_1[]={0,0,0,0};
	if (pointer!=NULL) pointer_=&pointer[0];
	else pointer_=&pointer_1[0];

	int i;
	double x[2],y[2];
	double cells=0;
	double cells1=0;
	for(i=0;i<x_size-1;i++)
	{
		cells+=(double)f1.b1*(i+pointer_[0])+f1.b2;
		cells1+=(double)f4.b1*(i+pointer_[3])+f4.b2;
		if (main_l.l[0].b==1)
		{			
			x[0]=(double)main_p.p[0].x+pmu(main_p.p[2].x-main_p.p[0].x)*cells;			
			y[0]=main_l.l[0].b1*x[0]+main_l.l[0].b2;
		}
		if (main_l.l[0].b==2)
		{
			y[0]=(double)main_p.p[0].y+pmu(main_p.p[2].y-main_p.p[0].y)*cells;			
			x[0]=main_l.l[0].b1*y[0]+main_l.l[0].b2;
		}
		if (main_l.l[2].b==1)
		{
			x[1]=(double)main_p.p[3].x+pmu(main_p.p[1].x-main_p.p[3].x)*cells1;			
			y[1]=main_l.l[2].b1*x[1]+main_l.l[2].b2;
		}
		if (main_l.l[2].b==2)
		{
			y[1]=(double)main_p.p[3].y+pmu(main_p.p[1].y-main_p.p[3].y)*cells1;			
			x[1]=main_l.l[2].b1*y[1]+main_l.l[2].b2;
		}
		l[i]=MakeLine(x[0],y[0],x[1],y[1]);
	}
	cells=0;
	cells1=0;	
	for(i=0;i<y_size-1;i++)
	{
		cells+=(double)f2.b1*(y_size-1-(i+pointer_[1]))+f2.b2;
		cells1+=(double)f3.b1*(y_size-1-(i+pointer_[2]))+f3.b2;
		if (main_l.l[1].b==1)
		{			
			x[0]=(double)main_p.p[2].x+pmu(main_p.p[1].x-main_p.p[2].x)*cells;			
			y[0]=main_l.l[1].b1*x[0]+main_l.l[1].b2;
		}
		if (main_l.l[1].b==2)
		{
			y[0]=(double)main_p.p[2].y+pmu(main_p.p[1].y-main_p.p[2].y)*cells;			
			x[0]=main_l.l[1].b1*y[0]+main_l.l[1].b2;
		}
		if (main_l.l[3].b==1)
		{
			x[1]=(double)main_p.p[0].x+pmu(main_p.p[3].x-main_p.p[0].x)*cells1;			
			y[1]=main_l.l[3].b1*x[1]+main_l.l[3].b2;
		}
		if (main_l.l[3].b==2)
		{
			y[1]=(double)main_p.p[0].y+pmu(main_p.p[3].y-main_p.p[0].y)*cells1;			
			x[1]=main_l.l[3].b1*y[1]+main_l.l[3].b2;
		}
		l[i+x_size-1]=MakeLine(x[0],y[0],x[1],y[1]);
	}

	return 0;
}

int GRID::CreateGrid(FOUR_FIG_P pp)
{
	main_p.p[0]=PointID(pp.p[0]);
	main_p.p[1]=PointID(pp.p[1]);
	main_p.p[2]=PointID(pp.p[2]);
	main_p.p[3]=PointID(pp.p[3]);
	main_l.l[0]=MakeLine(main_p.p[0],main_p.p[2]);
	main_l.l[1]=MakeLine(main_p.p[2],main_p.p[1]);
	main_l.l[2]=MakeLine(main_p.p[1],main_p.p[3]);
	main_l.l[3]=MakeLine(main_p.p[3],main_p.p[0]);


	int i;
	double x[2],y[2];
	for(i=0;i<x_size-1;i++)
	{
		if (main_l.l[0].b==1)
		{			
			x[0]=(double)main_p.p[0].x+(double)(i+1)*(main_p.p[2].x-main_p.p[0].x)/x_size;			
			y[0]=main_l.l[0].b1*x[0]+main_l.l[0].b2;
		}
		if (main_l.l[0].b==2)
		{
			y[0]=(double)main_p.p[0].y+(double)(i+1)*(main_p.p[2].y-main_p.p[0].y)/x_size;			
			x[0]=main_l.l[0].b1*y[0]+main_l.l[0].b2;
		}
		if (main_l.l[2].b==1)
		{
			x[1]=(double)main_p.p[3].x+(double)(i+1)*(main_p.p[1].x-main_p.p[3].x)/x_size;			
			y[1]=main_l.l[2].b1*x[1]+main_l.l[2].b2;
		}
		if (main_l.l[2].b==2)
		{
			y[1]=(double)main_p.p[3].y+(double)(i+1)*(main_p.p[1].y-main_p.p[3].y)/x_size;			
			x[1]=main_l.l[2].b1*y[1]+main_l.l[2].b2;
		}
		l[i]=MakeLine(x[0],y[0],x[1],y[1]);
	}

	for(i=0;i<y_size-1;i++)
	{
		if (main_l.l[1].b==1)
		{
			/*if (main_p.p[0].x<main_p.p[2].x)*/ 
			x[0]=(double)main_p.p[2].x+(double)(i+1)*(main_p.p[1].x-main_p.p[2].x)/y_size;			
			y[0]=main_l.l[1].b1*x[0]+main_l.l[1].b2;
		}
		if (main_l.l[1].b==2)
		{
			y[0]=(double)main_p.p[2].y+(double)(i+1)*(main_p.p[1].y-main_p.p[2].y)/y_size;			
			x[0]=main_l.l[1].b1*y[0]+main_l.l[1].b2;
		}
		if (main_l.l[3].b==1)
		{
			x[1]=(double)main_p.p[0].x+(double)(i+1)*(main_p.p[3].x-main_p.p[0].x)/y_size;			
			y[1]=main_l.l[3].b1*x[1]+main_l.l[3].b2;
		}
		if (main_l.l[3].b==2)
		{
			y[1]=(double)main_p.p[0].y+(double)(i+1)*(main_p.p[3].y-main_p.p[0].y)/y_size;			
			x[1]=main_l.l[3].b1*y[1]+main_l.l[3].b2;
		}
		l[i+x_size-1]=MakeLine(x[0],y[0],x[1],y[1]);
	}
	
	return 0;
}

int GRID::CreateGrid(FOUR_FIG_Pd pp)
{
	main_p=pp;
	main_l.l[0]=MakeLine(main_p.p[0],main_p.p[2]);
	main_l.l[1]=MakeLine(main_p.p[2],main_p.p[1]);
	main_l.l[2]=MakeLine(main_p.p[1],main_p.p[3]);
	main_l.l[3]=MakeLine(main_p.p[3],main_p.p[0]);


	int i;
	double x[2],y[2];
	for(i=0;i<x_size-1;i++)
	{
		if (main_l.l[0].b==1)
		{
			/*if (main_p.p[0].x<main_p.p[2].x)*/ 
			x[0]=(double)main_p.p[0].x+(double)(i+1)*(main_p.p[2].x-main_p.p[0].x)/x_size;			
			y[0]=main_l.l[0].b1*x[0]+main_l.l[0].b2;
		}
		if (main_l.l[0].b==2)
		{
			y[0]=(double)main_p.p[0].y+(double)(i+1)*(main_p.p[2].y-main_p.p[0].y)/x_size;			
			x[0]=main_l.l[0].b1*y[0]+main_l.l[0].b2;
		}
		if (main_l.l[2].b==1)
		{
			x[1]=(double)main_p.p[3].x+(double)(i+1)*(main_p.p[1].x-main_p.p[3].x)/x_size;			
			y[1]=main_l.l[2].b1*x[1]+main_l.l[2].b2;
		}
		if (main_l.l[2].b==2)
		{
			y[1]=(double)main_p.p[3].y+(double)(i+1)*(main_p.p[1].y-main_p.p[3].y)/x_size;			
			x[1]=main_l.l[2].b1*y[1]+main_l.l[2].b2;
		}
		l[i]=MakeLine(x[0],y[0],x[1],y[1]);
	}

	for(i=0;i<y_size-1;i++)
	{
		if (main_l.l[1].b==1)
		{
			/*if (main_p.p[0].x<main_p.p[2].x)*/ 
			x[0]=(double)main_p.p[2].x+(double)(i+1)*(main_p.p[1].x-main_p.p[2].x)/y_size;			
			y[0]=main_l.l[1].b1*x[0]+main_l.l[1].b2;
		}
		if (main_l.l[1].b==2)
		{
			y[0]=(double)main_p.p[2].y+(double)(i+1)*(main_p.p[1].y-main_p.p[2].y)/y_size;			
			x[0]=main_l.l[1].b1*y[0]+main_l.l[1].b2;
		}
		if (main_l.l[3].b==1)
		{
			x[1]=(double)main_p.p[0].x+(double)(i+1)*(main_p.p[3].x-main_p.p[0].x)/y_size;			
			y[1]=main_l.l[3].b1*x[1]+main_l.l[3].b2;
		}
		if (main_l.l[3].b==2)
		{
			y[1]=(double)main_p.p[0].y+(double)(i+1)*(main_p.p[3].y-main_p.p[0].y)/y_size;			
			x[1]=main_l.l[3].b1*y[1]+main_l.l[3].b2;
		}
		l[i+x_size-1]=MakeLine(x[0],y[0],x[1],y[1]);
	}
	
	return 0;
}


F_LINE GRID::GetLine(int num)
{
	return l[num];
}

/*
   ,      ,   
    
*/


int GRID::RecogCells(IMG img)//   8-  
{
	if (img.format!=1) return 1;
	int i,j;
	int i1,j1,j2;
	F_LINE lines[4];
	F_LINE diag[2];
	double x[4],y[4];
	double cx,cy;
	int cxx,cyy;
	double r1,r2,rm;
//	double f1[2],f2[2];
	double all_pixels;
	double black_pixels;
	int border_pixels;
	double tt;
	int a1,a2;

	double *Koef=new double[img.Width];
	memset((void*)Koef,0,img.Width*sizeof(double));	


	C_POINTd pp;
	C_POINTd pp1;
	int xmin,ymin,xmax,ymax;
	for(i=0;i<y_size;i++)
		for(j=0;j<x_size;j++)
		{
			if (i==0) lines[0]=main_l.l[0];
			else lines[0]=l[x_size-1+i-1];
			if (j==x_size-1) lines[1]=main_l.l[1];
			else lines[1]=l[j];
			if (i==y_size-1) lines[2]=main_l.l[2];
			else lines[2]=l[x_size-1+i];
			if (j==0) lines[3]=main_l.l[3];
			else lines[3]=l[j-1];
			// 4-    
			Intersection(lines[0],lines[3],x[0],y[0]);
			Intersection(lines[1],lines[2],x[1],y[1]);
			Intersection(lines[0],lines[1],x[2],y[2]);
			Intersection(lines[2],lines[3],x[3],y[3]);

			for(i1=0;i1<4;i1++)
			{
				if (x[i1]<-300 || x[i1]>10000) return 2;
			}


			
			//  
			diag[0]=MakeLine(x[0],y[0],x[1],y[1]);
			diag[1]=MakeLine(x[2],y[2],x[3],y[3]);
			//  
			r1=LengthLine(x[0],y[0],x[1],y[1]);
			r2=LengthLine(x[2],y[2],x[3],y[3]);
			if (r1<r2) rm=r1;
			else rm=r2;
			rm/=2;
			if (rm>=img.Width) {
				delete Koef;
				return 3;
			}
			//
			Intersection(diag[0],diag[1],cx,cy);
			//    			
			all_pixels=0;
			black_pixels=0;	
			border_pixels=0;
			//xmin=round(cx-rm);xmax=round(cx+rm);
			//ymin=round(cy-rm);ymax=round(cy+rm);
			pp.x=cx;
			pp.y=cy;
			//cxx=round(cx);
					
			//ReturnCountBlackPoints(img,pp,rm,all_pixels,black_pixels,border_pixels);
			
			xmin=round(cx-rm);xmax=round(cx+rm);
			ymin=round(cy-rm);ymax=round(cy+rm);
			// 2.5
			if (xmin<0) xmin=0;
			if (ymin<0) ymin=0;
			if (xmax>=img.Width) xmax=img.Width-1;
			if (ymax>=img.Height) ymax=img.Height-1;
			cxx=round(cx);
			cyy=round(cy);

			// 
			for(i1=0;i1<=rm+1;i1++) Koef[i1]=1-(double)i1/rm;

			for(i1=ymin;i1<=ymax;i1++)
			{
				j2=cxx+sqrt(absf((double)pow((double)rm,2)-pow((double)i1-cyy,2)));
				a1=abs(i1-cyy);
				j1=cxx-sqrt(absf((double)pow((double)rm,2)-pow((double)i1-cyy,2)));
				for(;j1<=j2;j1++)
				{
					a2=abs(j1-cxx);
					tt=Koef[a2+a1];
					all_pixels+=tt;
					if (img.bytes[i1*img.Width_1+j1]==0) black_pixels+=tt;
				}
			
			}
			
			if (all_pixels==0) return 2;//-     
			cells[i*x_size+j]=(double)black_pixels/all_pixels;			

		}
	delete Koef;
	return 0;
}


#ifdef ON_DEBUG
int GRID::RecogCells(IMG img,IMG img24)//   8-  
{
	if (img.format!=1) return 1;
	int i,j;
	int i1,j1,j2;
	F_LINE lines[4];
	F_LINE diag[2];
	double x[4],y[4];
	double cx,cy;
	int cxx,cyy;
	double r1,r2,rm;
//	double f1[2],f2[2];
	double all_pixels;
	double black_pixels;
	int border_pixels;
	double tt;
	int a1,a2;

	double *Koef=new double[img.Width];
	memset((void*)Koef,0,img.Width*sizeof(double));	

	//LOG_FILE log_file;
	//log_file.BLog("grid.log");


	C_POINTd pp;
	C_POINTd pp1;
	int xmin,ymin,xmax,ymax;	
	for(i=0;i<y_size;i++){
		//log_file.Log("1");
		for(j=0;j<x_size;j++)
		{
			if (i==0) lines[0]=main_l.l[0];
			else lines[0]=l[x_size-1+i-1];
			if (j==x_size-1) lines[1]=main_l.l[1];
			else lines[1]=l[j];
			if (i==y_size-1) lines[2]=main_l.l[2];
			else lines[2]=l[x_size-1+i];
			if (j==0) lines[3]=main_l.l[3];
			else lines[3]=l[j-1];
			// 4-    
			Intersection(lines[0],lines[3],x[0],y[0]);
			Intersection(lines[1],lines[2],x[1],y[1]);
			Intersection(lines[0],lines[1],x[2],y[2]);
			Intersection(lines[2],lines[3],x[3],y[3]);
			for(i1=0;i1<4;i1++)
			{
				if (x[i1]<-300 || x[i1]>10000) return 2;
			}

			//    - -    
			pp.x=x[0];pp.y=y[0];pp1.x=x[2];pp1.y=y[2];
			DrawLine(img24,PointDI(pp),PointDI(pp1),0,0,64);
			pp.x=x[2];pp.y=y[2];pp1.x=x[1];pp1.y=y[1];
			DrawLine(img24,PointDI(pp),PointDI(pp1),0,0,64);
			pp.x=x[1];pp.y=y[1];pp1.x=x[3];pp1.y=y[3];
			DrawLine(img24,PointDI(pp),PointDI(pp1),0,0,64);
			pp.x=x[3];pp.y=y[3];pp1.x=x[0];pp1.y=y[0];
			DrawLine(img24,PointDI(pp),PointDI(pp1),0,0,64);
			
			//  
			diag[0]=MakeLine(x[0],y[0],x[1],y[1]);
			diag[1]=MakeLine(x[2],y[2],x[3],y[3]);
			//  
			r1=LengthLine(x[0],y[0],x[1],y[1]);
			r2=LengthLine(x[2],y[2],x[3],y[3]);
			if (r1<r2) rm=r1;
			else rm=r2;
			rm/=2;
			if (rm>=img.Width) {
				delete Koef;
				return 3;
			}
			//
			Intersection(diag[0],diag[1],cx,cy);
			//    			
			all_pixels=0;
			black_pixels=0;	
			border_pixels=0;			
			pp.x=cx;
			pp.y=cy;		

			
			xmin=round(cx-rm);xmax=round(cx+rm);
			ymin=round(cy-rm);ymax=round(cy+rm);
			// 2.5
			if (xmin<0) xmin=0;
			if (ymin<0) ymin=0;
			if (xmax>=img.Width) xmax=img.Width-1;
			if (ymax>=img.Height) ymax=img.Height-1;
			cxx=round(cx);						
			cyy=round(cy);

			// 
			for(i1=0;i1<=rm+1;i1++) Koef[i1]=1-(double)i1/rm;

			for(i1=ymin;i1<=ymax;i1++)
			{
				j2=cxx+sqrt(absf((double)pow((double)rm,2)-pow((double)i1-cyy,2)));
				a1=abs(i1-cyy);
				j1=cxx-sqrt(absf((double)pow((double)rm,2)-pow((double)i1-cyy,2)));
				if (j2>img.Width && j2>img.Height) return 3;
				for(;j1<=j2;j1++)
				{
					a2=abs(j1-cxx);
					tt=Koef[a2+a1];
					all_pixels+=tt;
					if (img.bytes[i1*img.Width_1+j1]==0) black_pixels+=tt;
				}
			
			}
			
			if (all_pixels==0) return 2;//-     
			cells[i*x_size+j]=(double)black_pixels/all_pixels;
			if (cells[i*x_size+j]>=0.5)
			{
				pp.x=x[0];pp.y=y[0];pp1.x=x[1];pp1.y=y[1];
				DrawLine(img24,PointDI(pp),PointDI(pp1),255,0,0);
				pp.x=x[2];pp.y=y[2];pp1.x=x[3];pp1.y=y[3];
				DrawLine(img24,PointDI(pp),PointDI(pp1),255,0,0);
			}
			
		}
	}
	//log_file.Log("End");
	delete Koef;
	return 0;
}
#endif

int GRID::ReturnBlackCells(double delta)
{
	int i,j;

	int all=0;
	for(i=0;i<y_size;i++)
		for(j=0;j<x_size;j++)
			if (cells[i*x_size+j]>delta) all++;

	return all;
}

void GRID::ReturnGrid(double delta,bool &array)
{
	bool* a=&array;
	int i,j;
	for(i=0;i<y_size;i++)
		for(j=0;j<x_size;j++)
		{
			if (cells[i*x_size+j]>delta) a[i*x_size+j]=1;
			else a[i*x_size+j]=0;
		}
}

// ,    Aztec 
void GRID::ReturnGrid1(double delta,bool &array)
{
	bool* a=&array;
	int i,j,k=0;
	for(j=0;j<x_size;j++)
		for(i=y_size-1;i>=0;i--)		
		{
			if (cells[i*x_size+j]>delta) a[k]=1;
			else a[k]=0;
			k++;
		}
}
/*
    GRID     -    
 img   center   radius
*/
int ReturnCountBlackPoints(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points)
{
	if (img.format!=1) return 1;

	int xmin,ymin,xmax,ymax;
	int i1,j1;
	int cxx;
	xmin=round(center.x-radius);xmax=round(center.x+radius);
	ymin=round(center.y-radius);ymax=round(center.y+radius);
	cxx=round(center.x);

	if (xmin<0) xmin=0;
	if (ymin<0) ymin=0;
	if (xmax>=img.Width) xmax=img.Width-1;
	if (ymax>=img.Height) ymax=img.Height-1;

	for(i1=ymin;i1<=ymax;i1++)
	{
		for(j1=cxx;j1>=xmin;j1--)
		{
			if (LengthLine(center.x,center.y,j1,i1)>radius) break;
			all_points++;
			if (img.bytes[i1*img.Width_1+j1]==0) black_points++;
			if (img.bytes[i1*img.Width_1+j1]==128) border_points++;
		}
		for(j1=cxx+1;j1<=xmax;j1++)
		{
			if (LengthLine(center.x,center.y,j1,i1)>radius) break;
			all_points++;
			if (img.bytes[i1*img.Width_1+j1]==0) black_points++;
			if (img.bytes[i1*img.Width_1+j1]==128) border_points++;
		}
	}
	return 0;
}


// ,     
int ReturnCountBlackPointsBr(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points,C_POINTd &border)
{
	if (img.format!=1) return 1;

	int xmin,ymin,xmax,ymax;
	int i1,j1;
	int cxx;
	xmin=round(center.x-radius);xmax=round(center.x+radius);
	ymin=round(center.y-radius);ymax=round(center.y+radius);
	cxx=round(center.x);

	if (xmin<0) xmin=0;
	if (ymin<0) ymin=0;
	if (xmax>=img.Width) xmax=img.Width-1;
	if (ymax>=img.Height) ymax=img.Height-1;

	for(i1=ymin;i1<=ymax;i1++)
	{
		for(j1=cxx;j1>=xmin;j1--)
		{
			if (LengthLine(center.x,center.y,j1,i1)>radius) break;
			all_points++;
			if (img.bytes[i1*img.Width_1+j1]==0) black_points++;
			if (img.bytes[i1*img.Width_1+j1]==128) {
				border_points++;
			if (border_points==1)
			{
				border.x=j1;
				border.y=i1;
			}
			else
			{
				border.x+=j1;
				border.y+=i1;
			}
			}
		}
		for(j1=cxx+1;j1<=xmax;j1++)
		{
			if (LengthLine(center.x,center.y,j1,i1)>radius) break;
			all_points++;
			if (img.bytes[i1*img.Width_1+j1]==0) black_points++;
			if (img.bytes[i1*img.Width_1+j1]==128) {
				border_points++;
			if (border_points==1)
			{
				border.x=j1;
				border.y=i1;
			}
			else
			{
				border.x+=j1;
				border.y+=i1;
			}
			}
		}
	}
	border.x=(double)border.x/border_points;
	border.y=border.y/(double)border_points;
	return 0;
}
