/*	______________________________________________________________________

	grid.h  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	   -   	
	______________________________________________________________________
*/
#ifndef _GRID_
#define _GRID_ 1

#include "img.h"
#include "math_a.h"
//#include "log_file.h"


class IMAGEPAK GRID
{
private:
	int x_size,y_size;
	FOUR_FIG_Pd main_p;
	FOUR_FIG_L main_l;
	//FOUR_FIG_P* p;
	F_LINE* l;
	double* cells;//   
public:
	GRID(int x,int y);//       
	~GRID();//
	int CreateGrid(FOUR_FIG_P pp);//       
	int CreateGrid(FOUR_FIG_Pd pp);//       
	int CreateGrid(FOUR_FIG_Pd pp,F_LINE f1,F_LINE f2,F_LINE f3,F_LINE f4,int*pointer=NULL);//         
	//  
	/*
	0 ----- 2
	|       |
	3 ----- 1
	    0)  0  2; 1)  1  2; 2)  3  0; 3)  3  1.
	  x   0 (         24   ..)
	*/
	F_LINE GetLine(int num);//   
	int RecogCells(IMG img);//   8-  
#ifdef ON_DEBUG
	int RecogCells(IMG img,IMG img24);//   8-  
#endif
	int ReturnBlackCells(double delta);//  -  ,    delta (0-, 1 - )
	void ReturnGrid(double delta,bool &array);//   1-  0 -	
	void ReturnGrid1(double delta,bool &array);// ,    Aztec 
};

extern "C"
{
IMAGEPAK int ReturnCountBlackPoints(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points);
IMAGEPAK int ReturnCountBlackPointsBr(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points,C_POINTd &border);

}
#endif