/*	______________________________________________________________________

	img.h  Version 1.04
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	   -  24 
	______________________________________________________________________
*/
#ifndef _IMG_
#define _IMG_ 1

//#define ON_DEBUG 1
//#define ON_DEBUG1 1

#define WINDOWS_PR 1

#ifdef WINDOWS_PR
#include <windows.h>
#include < olectl.h>
#endif


#include "geometry.h"


	#define THRESH_BINARY_INV		1
	#define ALLOCATE_WHITE			1


#ifndef byte
typedef unsigned char byte;
#endif

#ifndef DWORD
typedef unsigned long DWORD;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

/*#ifndef RECT
struct RECT { 
  long left; 
  long top; 
  long right; 
  long bottom; 
}; 
#endif*/


//  24  
struct IMG
{
	byte* bytes;
	int Width;
	int Width_1;
	int Height;
	bool on;
	//    ,    -  24 
	BYTE format;//0 - 24 1 - 8   
};


extern "C"
{

IMAGEPAK IMG OpenDF(char* filename);

}
IMAGEPAK int DrawLine(IMG img,F_LINE,byte c1,byte c2,byte c3);
extern "C"
{
IMAGEPAK int DrawLine(IMG img, C_POINT p1,C_POINT p2,byte c1,byte c2,byte c3);
}

extern "C"
{
IMAGEPAK int DrawRect(IMG img,RECT rect,byte c1,byte c2,byte c3);


//  
IMAGEPAK int UpDownImage(IMG img);

#ifdef WINDOWS_PR
// jpeg,gif  bmp
IMAGEPAK HBITMAP LoadPictureFile(LPCTSTR szFile);
IMAGEPAK IMG OpenGraphFile(char* filename);
IMAGEPAK int SaveDF(char* filename,IMG img);
// 
IMAGEPAK int CopyIMG(IMG in,IMG &out);
#endif

//
IMAGEPAK IMG Transform1(IMG Img);


//  
IMAGEPAK void ThresholdImage(IMG Img,byte param,RECT rect);
IMAGEPAK IMG AdaptiveThresholdImage(IMG Img,int block_size,RECT rect,DWORD flags);
IMAGEPAK void Adaptive2ThresholdImage(IMG Img,byte param,byte delta,RECT rect,int pixels);

// 
IMAGEPAK void AllocationBorders(IMG img);
IMAGEPAK void AllocationBordersRect(IMG img,RECT r, DWORD flags);

//      
IMAGEPAK IMG ReduceImage(IMG img,int param);

//    
IMAGEPAK IMG IncreaseImg(IMG img,int param);

//  8  
IMAGEPAK IMG Img24To8(IMG Img);

//  24 
IMAGEPAK IMG Img8To24(IMG Img);

// 
IMAGEPAK void ClearImage(IMG img);

// 
IMAGEPAK void DrawPoint(IMG img,int x,int y,byte c1,byte c2,byte c3);

IMAGEPAK void DrawFillRect(IMG Img,RECT Rect,byte c1,byte c2,byte c3);

IMAGEPAK void DeleteImg(IMG Img);
}

#endif
