/*	______________________________________________________________________

	img_transf.cpp  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	 
	______________________________________________________________________
*/

#include "img_transf.h"

//Img    
IMG Img_Dilate(IMG Img)
{
	IMG Image;
	Image.on=0;

	//   8  
	if (Img.format!=1 || !Img.on || Img.Width<3 || Img.Width_1<3 || Img.Height<3) return Image;			

	Image.Height=Img.Height;
	Image.Width=Img.Width;
	Image.Width_1=Img.Width_1;
	Image.on=true;
	Image.format=Img.format;

	Image.bytes=new byte[Image.Width_1*Image.Height];

	int i,j,k;
	byte max;

	for(i=0;i<Image.Height;i++)
		for(j=0;j<Image.Width;j++)
			if (i==0 || j==0 || i==Image.Height-1 || j==Image.Width-1) 
				Image.bytes[i*Image.Width_1+j]=Img.bytes[i*Image.Width_1+j];
			else
			{
				max=Img.bytes[(i-1)*Image.Width_1+j-1];
				for(k=1;k<9;k++)
					if (Img.bytes[(i-1+(int)k/3)*Image.Width_1+j-1+(int)k%3]>max) 
						max=Img.bytes[(i-1+(int)k/3)*Image.Width_1+j-1+(int)k%3];
				Image.bytes[i*Image.Width_1+j]=max;
			}

	delete Img.bytes;
	Img.on=0;

	return Image;
}

//Img    
IMG Img_Erode(IMG Img)
{
	IMG Image;
	Image.on=0;

	//   8  
	if (Img.format!=1 || !Img.on || Img.Width<3 || Img.Width_1<3 || Img.Height<3) return Image;			

	Image.Height=Img.Height;
	Image.Width=Img.Width;
	Image.Width_1=Img.Width_1;
	Image.on=true;
	Image.format=Img.format;

	Image.bytes=new byte[Image.Width_1*Image.Height];

	int i,j,k;
	byte min;

	for(i=0;i<Image.Height;i++)
		for(j=0;j<Image.Width;j++)
			if (i==0 || j==0 || i==Image.Height-1 || j==Image.Width-1) 
				Image.bytes[i*Image.Width_1+j]=Img.bytes[i*Image.Width_1+j];
			else
			{
				min=Img.bytes[(i-1)*Image.Width_1+j-1];
				for(k=1;k<9;k++)
					if (Img.bytes[(i-1+(int)k/3)*Image.Width_1+j-1+(int)k%3]<min) 
						min=Img.bytes[(i-1+(int)k/3)*Image.Width_1+j-1+(int)k%3];
				Image.bytes[i*Image.Width_1+j]=min;
			}

	delete Img.bytes;
	Img.on=0;

	return Image;
}