/*	______________________________________________________________________

	math_a.h  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	  	
	______________________________________________________________________
*/

#include "math_a.h"


// 
double M_e(int all,double*ptr)
{
	double M=0;
	for(int i=0;i<all;i++)
		M+=ptr[i];

	return (double)M/all;
}

double M_e(int all,int*ptr)
{
	double M=0;
	for(int i=0;i<all;i++)
		M+=ptr[i];

	return (double)M/all;
}

//
double D_e(int all,double*ptr,double M)
{
	double D=0;
	for(int i=0;i<all;i++)
		D+=pow(ptr[i]-M,2);
	return (double)D/all;
}

double D_e(int all,int*ptr,double M)
{
	double D=0;
	for(int i=0;i<all;i++)
		D+=pow(ptr[i]-M,2);
	return (double)D/all;
}

double pmu(double a)
{
	return a>0 ? 1 : -1;
}

double min_(double a1,double a2)
{
	return a1<a2 ? a1 : a2;
}

double max_(double a1,double a2)
{
	return a1>a2 ? a1 : a2;
}

double KPK_e(int all,double *p,double *p1,double m,double m1,double d,double d1)
{
	double q;

	int i;

	q=0;

	for(i=0;i<all;i++)
		q+=(double)(p[i]-m)*(p1[i]-m1);

	q=(double)q/(all*sqrt(d)*sqrt(d1));

	return q;
}


double KPK_e(int all,int *p,int *p1,double m,double m1,double d,double d1)
{
	double q;

	int i;

	q=0;

	for(i=0;i<all;i++)
		q+=(double)(p[i]-m)*(p1[i]-m1);

	q=(double)q/(all*sqrt(d)*sqrt(d1));

	return q;
}