/*	______________________________________________________________________

	contour.h  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	  	
	 :
	1.01 -     AccuracyLine
	______________________________________________________________________
*/
#ifndef _CONTOUR_
#define _CONTOUR_ 1

#include "img.h"
#include "math_a.h"

//    
#define MAX_CONTOUR 10000

//
#define CONTOUR_AUTO_INOUT				0x01     //    
#define CONTOUR_CONSISTENTLY			0x02	 //   


struct CONTOUR_STRUCT
{
	WORD all_elem;//     
	C_POINT* Points;//   
	RECT Zone;// 
	int mama;//  -1,   
	int level;// 
};


class IMAGEPAK CONTOUR
{
private:
	int all_contour;
	CONTOUR_STRUCT Contours[MAX_CONTOUR];
	//   
	int all_elem;
	C_POINT *Point;
	RECT Zone;
	void FindBorderPoint(int x,int y);
	void FindBorderPoint1(int x,int y);
	byte c1;
	RECT rect;
	//  
	IMG Image;
public:
	CONTOUR();
	~CONTOUR();
	int Find(IMG img,RECT rect,byte c,DWORD flags);//     8 
	int DrawContour(IMG img,int num_counter,byte c1,byte c2,byte c3);// 
	int DrawContours(IMG img,byte c1,byte c2,byte c3);//  
	void ReturnMaxLevel(int &level,int &first,int &all);//         

	C_POINT ReturnCenterContour(int num_con);//  
	bool ReturnPointInContour(C_POINT c,int num_contour);//       
	int GetMama(int num_contour);//  
	int Return4DistantPoints(C_POINT &c_p,int num_contour);// 4      
	int PointsInLine(F_LINE line,int num_contour);//    
	int AllPoints(int num_contour);//  all_elem
	//int MakeSequence(int num_contour);//   
	int Accuracy4RombPoints(C_POINT &c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour);// 4    Return4DistantPoints
	int ReturnAllContours();//   
	RECT ReturnRectContour(int num_con);//   
	int AccuracyLine(C_POINT& c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour,int &all_point,double &result,DWORD flags=0);// -          - 
};

#endif