/*	______________________________________________________________________

	detect_img.cpp  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	    	
	______________________________________________________________________
*/
#include "detect_img.h"

//image_code -   
//reduce -      
//AllDetectedCode -   
// 
int DetectCode(IMG image_code,int reduce,int &AllDetectedCode,RECT *DetectedCode)
{
	AllDetectedCode=0;
	//    
	IMG img=ReduceImage(image_code,reduce);

	// 
	AllocationBorders(img);
#ifdef ON_DEBUG1
	SaveDF("m_1.bmp",img);
#endif

	//    20*20 
	const int x=20;
	const int y=20;
	const int all_delta=10;
	const int min_delta=0;

	int array[x*y];	
	int array_x[x*y];	
	int array_y[x*y];	
	int p,p1;


	int i,j;

	for(i=0;i<x*y;i++) array[i]=0;

	int kk=0;
	if (img.format==0) kk=3;
	if (img.format==1) kk=1;
	for(i=0;i<img.Height;i++)
		for(j=0;j<img.Width;j++)
			if (img.bytes[j*kk+i*img.Width_1]==128) array[((int)i*y/img.Height)*x+(int)j*x/img.Width]++;

	int current_rect=0;	
	//   
	for(i=0;i<x*y;i++) 
		if (array[i]>all_delta)
		{
			//       -  
			array[i]=-1-current_rect;
			//        
			p=1;
			array_x[0]=i%x;
			array_y[0]=i/x;
			p1=0;
			do{
				if (p1>=p) break;

				// 
				if (array_x[p1]>0 && array[array_x[p1]-1+array_y[p1]*x]>all_delta)
				{
					array[array_x[p1]-1+array_y[p1]*x]=-1-current_rect;
					array_x[p]=array_x[p1]-1;
					array_y[p]=array_y[p1];
					p++;
				}
				if (array_x[p1]<x-1 && array[array_x[p1]+1+array_y[p1]*x]>all_delta)
				{
					array[array_x[p1]+1+array_y[p1]*x]=-1-current_rect;
					array_x[p]=array_x[p1]+1;
					array_y[p]=array_y[p1];
					p++;
				}
				if (array_y[p1]>0 && array[array_x[p1]+(array_y[p1]-1)*x]>all_delta)
				{
					array[array_x[p1]+(array_y[p1]-1)*x]=-1-current_rect;
					array_x[p]=array_x[p1];
					array_y[p]=array_y[p1]-1;
					p++;
				}
				if (array_y[p1]<y-1 && array[array_x[p1]+(array_y[p1]+1)*x]>all_delta)
				{
					array[array_x[p1]+(array_y[p1]+1)*x]=-1-current_rect;
					array_x[p]=array_x[p1];
					array_y[p]=array_y[p1]+1;
					p++;
				}

				p1++;
			}while(true);
			//     -1-current_rect ,    - 
			for(j=0;j<x*y;j++) 
				if (array[j]==-1-current_rect)
				{
					if (j%x>0 && array[j-1]>min_delta) array[j-1]=-1-current_rect;					
					if (j%x<x-1 && array[j+1]>min_delta) array[j+1]=-1-current_rect;					
					if (j/x>0 && array[j-x]>min_delta) array[j-x]=-1-current_rect;					
					if (j/x<y-1 && array[j+x]>min_delta) array[j+x]=-1-current_rect;					
				}
			//  RECT
			DetectedCode[AllDetectedCode].top=-1;
			for(j=0;j<x*y;j++) 
				if (array[j]==-1-current_rect)
				{
					if (DetectedCode[AllDetectedCode].top==-1)
					{
						DetectedCode[AllDetectedCode].top=((int)j/x)*((int)img.Height/y)*reduce;
						DetectedCode[AllDetectedCode].bottom=(1+(int)j/x)*((int)img.Height/y)*reduce;
						DetectedCode[AllDetectedCode].left=((int)j%x)*((int)img.Width/x)*reduce;						
						DetectedCode[AllDetectedCode].right=(1+(int)j%x)*((int)img.Width/x)*reduce;
					}
					else
					{
						if (DetectedCode[AllDetectedCode].top>((int)j/x)*((int)img.Height/y)*reduce)
							DetectedCode[AllDetectedCode].top=((int)j/x)*((int)img.Height/y)*reduce;
						if  (DetectedCode[AllDetectedCode].bottom<(1+(int)j/x)*((int)img.Height/y)*reduce)
							DetectedCode[AllDetectedCode].bottom=(1+(int)j/x)*((int)img.Height/y)*reduce;
						if (DetectedCode[AllDetectedCode].left>((int)j%x)*((int)img.Width/x)*reduce)
							DetectedCode[AllDetectedCode].left=((int)j%x)*((int)img.Width/x)*reduce;						
						if (DetectedCode[AllDetectedCode].right<(1+(int)j%x)*((int)img.Width/x)*reduce)
							DetectedCode[AllDetectedCode].right=(1+(int)j%x)*((int)img.Width/x)*reduce;
					}
				}
			current_rect++;
			//         ,    
			if (DetectedCode[AllDetectedCode].right-DetectedCode[AllDetectedCode].left>
				(double)1.8*(DetectedCode[AllDetectedCode].bottom-DetectedCode[AllDetectedCode].top) ||
				DetectedCode[AllDetectedCode].bottom-DetectedCode[AllDetectedCode].top>(double)1.8*(DetectedCode[AllDetectedCode].right-DetectedCode[AllDetectedCode].left)) ;
			else AllDetectedCode++;
		}

	//     
	delete img.bytes;

	

	return 0;
}