/*	______________________________________________________________________

	histogram.h  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	Histogram -   
	______________________________________________________________________
*/

#ifndef _HISTO_
#define _HISTO_ 

#include "img.h"
#include "math_a.h"

#define HIST_COMP_CHISQR			1


struct HISTO_1D
{
	int AllElem;
	long pixels;
	int *data;
};
extern "C"
{

IMAGEPAK HISTO_1D MakeHistogramIMG(IMG Img,RECT Rect,int AllElem);//   8- 
IMAGEPAK HISTO_1D CreateHistogram(int AllElem);//  
IMAGEPAK void DeleteHistogram(HISTO_1D h);// 
IMAGEPAK int DrawHistogram(HISTO_1D h,IMG Img);//     24- 
IMAGEPAK int MaxHistogramElem(HISTO_1D h);//    
IMAGEPAK double CompareHist(HISTO_1D h1,HISTO_1D h2,DWORD flags);

//
IMAGEPAK double CompareHistogram(HISTO_1D h1,HISTO_1D h2);//  
IMAGEPAK int CompareHistogram1(HISTO_1D h1,HISTO_1D h2,double threshold);//   
}

#endif