/*	______________________________________________________________________

	img.cpp  Version 1.04
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	   -  24 	
	______________________________________________________________________
*/
#include "img.h"


// 24 
IMG OpenDF(char* filename)
{
	IMG img;
	img.on=false;
	
	FILE *f;
	//open file
	f=fopen(filename,"rb");
	if (f==NULL) return img;	

	long l=0;
	int k=0;
	char ch;
	char* buf[20];
	DWORD offset=0;
	DWORD x=0,y=0;
	WORD Bit=0;
	DWORD a,Size=0;
	//read bmp file header
	do{
		if (l<2) ch=fgetc(f);
		if (l==2) fread(&buf,8,1,f);
		if (l==3) fread(&offset,4,1,f);
		if (l==4) fread(&buf,4,1,f);
		if (l==5) fread(&x,4,1,f);
		if (l==6) fread(&y,4,1,f);
		if (l==7) fread(&Bit,2,1,f);
		if (l==8) fread(&Bit,2,1,f);
		if (l==9) fread(&a,4,1,f);
		if (l==10) { fread(&Size,4,1,f); k=1; break;}
		if (l==0 && ch=='B') k=1;
		if (l==1 && ch=='M') k=1;
		if (l>1) k=1;
		if (l==8 && Bit!=24) k=0;
		if (l==9 && a!=0) k=0;
		if (k==0) break;
		l++;
		if (k>0) k--;
	}while(!feof(f));
	if (k==0 || offset==0 || x==0 || y==0 || Bit==0) {
		fclose(f);
		return img;
	}
	fseek(f,offset,SEEK_SET);
	img.Width=x;
	img.Height=y;
	img.format=0;
	if (img.Width*3%4==0) img.Width_1=img.Width*3;
        else img.Width_1=img.Width*3+4-img.Width*3%4;
	//separation memory
	img.bytes=new byte[img.Width_1*img.Height];
	fread((void*)img.bytes,img.Width_1*img.Height,1,f);
	fclose(f);	
	
	img.on=true;

	return img;	
}

#ifdef WINDOWS_PR
int SaveDF(char* filename,IMG img1)
{
	IMG img;
	if (img1.format==1)
	{
		img=Img8To24(img1);

	}
	else CopyIMG(img1,img);
	
	BITMAPFILEHEADER hdr; 
	BITMAPINFOHEADER pbih;
	pbih.biSize=sizeof(BITMAPINFOHEADER);
	pbih.biWidth=img.Width;
	pbih.biHeight=img.Height;
	pbih.biPlanes=1;
	pbih.biBitCount=24;
	pbih.biCompression=0;
	pbih.biSizeImage=img.Width_1*img.Height;
	pbih.biXPelsPerMeter=0;
	pbih.biYPelsPerMeter=0; 
	pbih.biClrUsed=0;
	pbih.biClrImportant=0;

	hdr.bfType = 0x4d42;  
	// Compute the size of the entire file. 
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
                 pbih.biSize + pbih.biClrUsed 
                 * sizeof(RGBQUAD) + pbih.biSizeImage);
    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 

    // Compute the offset to the array of color indices. 
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
                    pbih.biSize + pbih.biClrUsed 
                    * sizeof (RGBQUAD);
	FILE *f;
	f=fopen(filename,"wb");
	if (f==NULL) return 1;
	fwrite(&hdr,sizeof(BITMAPFILEHEADER),1,f);
	fwrite(&pbih,sizeof(BITMAPINFOHEADER),1,f);
	fwrite((void*)img.bytes,1,img.Width_1*img.Height,f);
	fclose(f);	

	delete img.bytes;
	return 0;
}
#endif



//    24 bit
int DrawLine(IMG img, F_LINE f,byte c1,byte c2,byte c3)
{
	int i;
	double a;
	int a1;
	if (f.b==1)
		for(i=0;i<img.Width;i++)
		{
			a=(double)f.b1*i+f.b2;
			a1=a;
			if (a1+0.5<a) a1++;
			if (a1<0 || a1>=img.Height) continue;
			img.bytes[i*3+a1*img.Width_1]=c1;
			img.bytes[i*3+a1*img.Width_1+1]=c2;
			img.bytes[i*3+a1*img.Width_1+2]=c3;
		}
	else	
		for(i=0;i<img.Height;i++)
		{
			a=(double)f.b1*i+f.b2;
			a1=a;
			if (a1+0.5<a) a1++;
			if (a1<0 || a1>=img.Width) continue;
			img.bytes[a1*3+i*img.Width_1]=c1;
			img.bytes[a1*3+i*img.Width_1+1]=c2;
			img.bytes[a1*3+i*img.Width_1+2]=c3;
		}
	return 0;
}

//    24 bit
int DrawLine(IMG img, C_POINT p1,C_POINT p2,byte c1,byte c2,byte c3)
{
	int i;
	double a;
	int a1;
	int min,max;
	F_LINE f=MakeLine(p1,p2);
	if (f.b==1)
	{
		if (p1.x<p2.x) { min=p1.x; max=p2.x;}
		else { min=p2.x; max=p1.x;}
		if (min<0) min=0;
		if (max>img.Width-1) max=img.Width-1;
		for(i=min;i<max;i++)
		{
			a=(double)f.b1*i+f.b2;
			a1=a;
			if (a1+0.5<a) a1++;
			if (a1<0 || a1>=img.Height) continue;
			if (i>=img.Width || i<0) continue;			
			img.bytes[i*3+a1*img.Width_1]=c1;
			img.bytes[i*3+a1*img.Width_1+1]=c2;
			img.bytes[i*3+a1*img.Width_1+2]=c3;
		}
	}
	else	{
		if (p1.y<p2.y) { min=p1.y; max=p2.y;}
		else { min=p2.y; max=p1.y;}
		if (min<0) min=0;
		if (max>img.Height-1) max=img.Height-1;
		for(i=min;i<max;i++)
		{
			a=(double)f.b1*i+f.b2;
			a1=a;
			if (a1+0.5<a) a1++;
			if (a1<0 || a1>=img.Width) continue;
			if (i>=img.Height || i<0) continue;			
			img.bytes[a1*3+i*img.Width_1]=c1;
			img.bytes[a1*3+i*img.Width_1+1]=c2;
			img.bytes[a1*3+i*img.Width_1+2]=c3;
		}
	}
	return 0;
}


#ifdef WINDOWS_PR
// 
int CopyIMG(IMG in,IMG &out)
{
	if (!in.on) return 1;
	if (in.Width<1 || in.Width_1<1 || in.Height<1) return 2;
	if (in.bytes==NULL) return 3;

	out.bytes=new byte[in.Width_1*in.Height];
	memcpy((void*)out.bytes,(void*)in.bytes,in.Width_1*in.Height);
	out.Height=in.Height;
	out.Width=in.Width;
	out.Width_1=in.Width_1;
	out.on=true;
	out.format=in.format;

	return 0;
}


HBITMAP LoadPictureFile(LPCTSTR szFile) {
    // open file
    HANDLE hFile = CreateFile(szFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
    //ATLVERIFY(INVALID_HANDLE_VALUE != hFile);
    if (hFile == INVALID_HANDLE_VALUE) {
        return NULL;
    }

    // get file size
    DWORD dwFileSize = GetFileSize(hFile, NULL);
    //ATLVERIFY(-1 != dwFileSize);
    if (dwFileSize == -1) {
        return NULL;
    }

    LPVOID pvData = NULL;
    // alloc memory based on file size
    HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, dwFileSize);
    //ATLVERIFY(NULL != hGlobal);
    if (hGlobal == NULL) {
        return NULL;
    }

    pvData = GlobalLock(hGlobal);
    //ATLVERIFY(NULL != pvData);
    if (pvData == NULL) {
        return NULL;
    }

    DWORD dwBytesRead = 0;
    // read file and store in global memory
    BOOL bRead = ReadFile(hFile, pvData, dwFileSize, &dwBytesRead, NULL);
    //ATLVERIFY(FALSE != bRead);
    if (bRead == FALSE) {
        return NULL;
    }

    GlobalUnlock(hGlobal);
    CloseHandle(hFile);

    LPSTREAM pstm = NULL;
    // create IStream* from global memory
    HRESULT hr = CreateStreamOnHGlobal(hGlobal, TRUE, &pstm);
    //ATLVERIFY(SUCCEEDED(hr) && pstm);
    if (!SUCCEEDED(hr) || !pstm) {
        return NULL;
    }

    // Create IPicture from image file
    LPPICTURE gpPicture;

    hr = ::OleLoadPicture(pstm, dwFileSize, FALSE, IID_IPicture, (LPVOID *)&gpPicture);
    //ATLVERIFY(SUCCEEDED(hr) && gpPicture);
    if (!SUCCEEDED(hr) || !gpPicture) {
        return NULL;
    } 

    pstm->Release();

    OLE_HANDLE m_picHandle;

    gpPicture->get_Handle(&m_picHandle);
    //        pBitmap->DeleteObject();
    GlobalFree(hGlobal);
#pragma warning (disable: 4312)
    return (HBITMAP)m_picHandle;
#pragma warning (default: 4312)
}

IMG OpenGraphFile(char* filename)
{
	IMG img;
	img.on=false;
	if (filename[0]==0) return img;	
	HDC dc=CreateCompatibleDC(NULL);
	img.on=false;

	BITMAPINFO Bmi;
    ZeroMemory(&Bmi,sizeof(BITMAPINFO));
    Bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);

	HBITMAP hBitmap=LoadPictureFile(filename);
    
	GetDIBits(dc,hBitmap,0,0,NULL,&Bmi,DIB_RGB_COLORS);

    img.Width=Bmi.bmiHeader.biWidth;
    img.Height=Bmi.bmiHeader.biHeight;
    if (img.Width*3%4==0) img.Width_1=img.Width*3;
    else img.Width_1=img.Width*3+4-img.Width*3%4;  
    
	if (img.Width_1==0 || img.Height==0) return img;
    
	img.bytes=new byte[img.Width_1*img.Height];    

    int i;
    
	i=GetDIBits(dc,hBitmap,0,Bmi.bmiHeader.biHeight,(void*)img.bytes,&Bmi,DIB_RGB_COLORS);
        

	

	ReleaseDC(NULL,dc);

	DeleteObject(hBitmap); hBitmap = NULL;

	if (img.Width==0 || img.Height==0) {
		img.bytes=NULL;
		return img;
	}

	img.on=true;
	img.format=0;

	return img;	
}
#endif


//  -    

IMG Transform1(IMG Img)
{
	long i;
	IMG img1;

	img1.on=false;

	img1.Width=Img.Width+20;
	img1.Height=Img.Height+20;
	

    if (img1.Width*3%4==0) img1.Width_1=img1.Width*3;
    else img1.Width_1=img1.Width*3+4-img1.Width*3%4;  

	img1.bytes=new byte[img1.Width_1*img1.Height];    
	for(i=0;i<Img.Height;i++)
		memcpy(&img1.bytes[i*img1.Width_1+10*3],&Img.bytes[i*Img.Width_1],Img.Width_1);
	
	img1.on=true;
	delete Img.bytes;

	return img1;
}

//   
int UpDownImage(IMG img)
{
	byte* b= new byte[img.Height*img.Width_1];

	int i;
	for(i=0;i<img.Height;i++)
		memcpy(&b[(img.Height-i-1)*img.Width_1],&img.bytes[i*img.Width_1],img.Width_1);

	memcpy(img.bytes,b,img.Width_1*img.Height);

	delete b;

	return 0;
}

//  
void ThresholdImage(IMG Img,byte param,RECT rect)
/*
Img -  
param -     
RECT - ,     
*/
{
	
	int i,j;
	double yyy;
	
	for(i=rect.top;i<rect.bottom;i++)
	for(j=rect.left;j<rect.right;j++)
	{	
		if (Img.format==1)
		{
			if (Img.bytes[j+i*Img.Width_1]>param) Img.bytes[j+i*Img.Width_1]=255;
			else Img.bytes[j+i*Img.Width_1]=0;
			continue;
		}
		yyy=(double)(0.071* Img.bytes[j*3+i*Img.Width_1]+
				 0.707*Img.bytes[j*3+i*Img.Width_1+1]+
				 0.222*Img.bytes[j*3+i*Img.Width_1+2]);
		if (yyy>param){
			Img.bytes[j*3+i*Img.Width_1]=255;
			Img.bytes[j*3+i*Img.Width_1+1]=255;
			Img.bytes[j*3+i*Img.Width_1+2]=255;
		}
		else
		{
			Img.bytes[j*3+i*Img.Width_1]=0;
			Img.bytes[j*3+i*Img.Width_1+1]=0;
			Img.bytes[j*3+i*Img.Width_1+2]=0;
		}			
	}

	
}

IMG AdaptiveThresholdImage(IMG Img,int block_size,RECT rect,DWORD flags)
/*
Img -  
block_size -   3,5,7...
RECT - ,     
flags -  
*/
{
	IMG img1;

	img1.on=false;

	img1.Width=Img.Width;
	img1.Width_1=Img.Width_1;
	img1.Height=Img.Height;
	img1.bytes=new byte[img1.Width_1*img1.Height]; 

	int i,j;
	int i1,j1,k;
	double yyy;
	double t;

	for(i=rect.top;i<rect.bottom;i++)
	for(j=rect.left;j<rect.right;j++)
	{
		k=0;
		t=0;
		for(i1=i-(block_size-1)/2;i1<=i+(block_size-1)/2;i1++)
			for(j1=j-(block_size-1)/2;j1<=j+(block_size-1)/2;j1++)
			{
				if (i1<0 || j1<0 || i1>=Img.Height || j1>=Img.Width) continue;
				k++;
				yyy=(double)(0.071* Img.bytes[j1*3+i1*Img.Width_1]+
				 0.707*Img.bytes[j1*3+i1*Img.Width_1+1]+
				 0.222*Img.bytes[j1*3+i1*Img.Width_1+2]);
				t+=yyy;
			}
		t=(t/k)-2;//2 -    (. opencv)
		yyy=(double)(0.071* Img.bytes[j*3+i*Img.Width_1]+
			0.707*Img.bytes[j*3+i*Img.Width_1+1]+
			0.222*Img.bytes[j*3+i*Img.Width_1+2]);
		if ((THRESH_BINARY_INV&flags)==THRESH_BINARY_INV) 
		{
			// 
			if (yyy>t)
			{
				img1.bytes[j*3+i*Img.Width_1]=0;
				img1.bytes[j*3+i*Img.Width_1+1]=0;
				img1.bytes[j*3+i*Img.Width_1+2]=0;
			}
			else
			{
				img1.bytes[j*3+i*Img.Width_1]=255;
				img1.bytes[j*3+i*Img.Width_1+1]=255;
				img1.bytes[j*3+i*Img.Width_1+2]=255;
			}
		}
		else
		{
			if (yyy>t)
			{
				img1.bytes[j*3+i*Img.Width_1]=255;
				img1.bytes[j*3+i*Img.Width_1+1]=255;
				img1.bytes[j*3+i*Img.Width_1+2]=255;
			}
			else
			{
				img1.bytes[j*3+i*Img.Width_1]=0;
				img1.bytes[j*3+i*Img.Width_1+1]=0;
				img1.bytes[j*3+i*Img.Width_1+2]=0;
			}
		}
	}

	
	img1.on=true;

	return img1;
}


void Adaptive2ThresholdImage(IMG Img,byte param,byte delta,RECT rect,int pixels)
/*
Img -  
param -     
delta -      
RECT - ,     
pixels -      ,        
*/
{
	//     
	int x=(rect.right-rect.left)/pixels;
	int y=(rect.bottom-rect.top)/pixels;
	byte *t=new byte[x*y];

	double all;
	double yyy;
	int i,j;
	int i1,j1;
	int pixels1=pixels*pixels;
	if (Img.format==0)
	{
		// 
		for(i=0;i<y;i++)
		for(j=0;j<x;j++)
		{
			all=0;
			for(i1=i*pixels;i1<(i+1)*pixels;i1++)
				for(j1=j*pixels;j1<(j+1)*pixels;j1++)
				{					
						all+=(double)(0.071* Img.bytes[j1*3+i1*Img.Width_1]+
						0.707*Img.bytes[j1*3+i1*Img.Width_1+1]+
						0.222*Img.bytes[j1*3+i1*Img.Width_1+2]);				
				}
			// 
			all=all/pixels1;
			t[j+i*x]=param-delta+(byte)all*delta*2/256;
		}
		//  
		for(i=rect.top;i<rect.bottom;i++)
		for(j=rect.left;j<rect.right;j++)
		{	
			
			yyy=(double)(0.071* Img.bytes[j*3+i*Img.Width_1]+
				 0.707*Img.bytes[j*3+i*Img.Width_1+1]+
				 0.222*Img.bytes[j*3+i*Img.Width_1+2]);	
			i1=i/pixels;
			j1=j/pixels;
			if (j1==x) j1=x-1;
			if (i1==y) i1=y-1;
			if (yyy>t[i1*x+j1]){
				Img.bytes[j*3+i*Img.Width_1]=255;
				Img.bytes[j*3+i*Img.Width_1+1]=255;
				Img.bytes[j*3+i*Img.Width_1+2]=255;
			}
			else
			{
				Img.bytes[j*3+i*Img.Width_1]=0;
				Img.bytes[j*3+i*Img.Width_1+1]=0;
				Img.bytes[j*3+i*Img.Width_1+2]=0;
			}		
		}
	}
	if (Img.format==1)
	{
		// 
		for(i=0;i<y;i++)
		for(j=0;j<x;j++)
		{
			all=0;
			for(i1=i*pixels;i1<(i+1)*pixels;i1++)
				for(j1=j*pixels;j1<(j+1)*pixels;j1++)
				{					
					if (Img.format==1) all+=Img.bytes[j1+i1*Img.Width_1];					
				}
			// 
			all=all/pixels1;
			t[j+i*x]=param-delta+(byte)all*delta*2/256;
		}
	//  
		for(i=rect.top;i<rect.bottom;i++)
		for(j=rect.left;j<rect.right;j++)
		{	
			yyy=Img.bytes[j+i*Img.Width_1];
			i1=i/pixels;
			j1=j/pixels;
			if (j1==x) j1=x-1;
			if (i1==y) i1=y-1;
			
			if (yyy>t[i1*x+j1])
				Img.bytes[j+i*Img.Width_1]=255;
				
			else
				Img.bytes[j+i*Img.Width_1]=0;
	
		}

	}	

	delete t;
}

//    
void AllocationBorders(IMG img)
{
	int i,j,k;
	if (img.format==0)
	for(i=0;i<img.Height;i++){
		for(j=0;j<img.Width;j++)
        {
			if (img.bytes[j*3+i*img.Width_1]==255) continue;
            k=0;
            if (i!=0)
				if (img.bytes[j*3+(i-1)*img.Width_1]==255) k=1;
			if (i!=img.Height-1)
                if (img.bytes[j*3+(i+1)*img.Width_1]==255) k=1;
			if (j!=0)
                if (img.bytes[(j-1)*3+i*img.Width_1]==255) k=1;
			if (j!=img.Width-1)
                if (img.bytes[(j+1)*3+i*img.Width_1]==255) k=1;
			if (k==1) {
                img.bytes[j*3+i*img.Width_1]=128;
                img.bytes[j*3+i*img.Width_1+1]=0;
                img.bytes[j*3+i*img.Width_1+2]=0;
            }

		}
	}      
	if (img.format==1)
	for(i=0;i<img.Height;i++){
		for(j=0;j<img.Width;j++)
        {
			if (img.bytes[j+i*img.Width_1]==255) continue;
            k=0;
            if (i!=0)
				if (img.bytes[j+(i-1)*img.Width_1]==255) k=1;
			if (i!=img.Height-1)
                if (img.bytes[j+(i+1)*img.Width_1]==255) k=1;
			if (j!=0)
                if (img.bytes[(j-1)+i*img.Width_1]==255) k=1;
			if (j!=img.Width-1)
                if (img.bytes[(j+1)+i*img.Width_1]==255) k=1;
			if (k==1) {
                img.bytes[j+i*img.Width_1]=128;
            }

		}
	} 

}

void AllocationBordersRect(IMG img,RECT r, DWORD flags)
{
	int i,j,k;
	if (img.format==0)
	for(i=r.top;i<r.bottom;i++){
		for(j=r.left;j<r.right;j++)
        {
			if (img.bytes[j*3+i*img.Width_1]!=0) continue;
			if ((ALLOCATE_WHITE&flags)==ALLOCATE_WHITE)
			{
				if (i!=0)
					if (img.bytes[j*3+(i-1)*img.Width_1]==255) img.bytes[j*3+(i-1)*img.Width_1]=128;
				if (i!=img.Height-1)
					if (img.bytes[j*3+(i+1)*img.Width_1]==255) img.bytes[j*3+(i+1)*img.Width_1]=128;
				if (j!=0)
					if (img.bytes[(j-1)*3+i*img.Width_1]==255) img.bytes[(j-1)*3+i*img.Width_1]=128;
				if (j!=img.Width-1)
				   if (img.bytes[(j+1)*3+i*img.Width_1]==255) img.bytes[(j+1)*3+i*img.Width_1]=128;
			}
			else
			{
				k=0;
				if (i!=0)
					if (img.bytes[j*3+(i-1)*img.Width_1]==255) k=1;
				if (i!=img.Height-1)
					if (img.bytes[j*3+(i+1)*img.Width_1]==255) k=1;
				if (j!=0)
					if (img.bytes[(j-1)*3+i*img.Width_1]==255) k=1;
				if (j!=img.Width-1)
				   if (img.bytes[(j+1)*3+i*img.Width_1]==255) k=1;
			}
			if ((ALLOCATE_WHITE&flags)==ALLOCATE_WHITE) continue;
			if (k==1) {
                img.bytes[j*3+i*img.Width_1]=128;
                //img.bytes[j*3+i*img.Width_1+1]=0;
                //img.bytes[j*3+i*img.Width_1+2]=0;
            }

		}
	}        

	if (img.format==1)
	for(i=r.top;i<r.bottom;i++){
		for(j=r.left;j<r.right;j++)
        {
			if (img.bytes[j+i*img.Width_1]!=0) continue;
			if ((ALLOCATE_WHITE&flags)==ALLOCATE_WHITE)
			{
				if (i!=0)
					if (img.bytes[j+(i-1)*img.Width_1]==255) img.bytes[j+(i-1)*img.Width_1]=128;
				if (i!=img.Height-1)
					if (img.bytes[j+(i+1)*img.Width_1]==255) img.bytes[j+(i+1)*img.Width_1]=128;
				if (j!=0)
					if (img.bytes[(j-1)+i*img.Width_1]==255) img.bytes[(j-1)+i*img.Width_1]=128;
				if (j!=img.Width-1)
				   if (img.bytes[(j+1)+i*img.Width_1]==255) img.bytes[(j+1)+i*img.Width_1]=128;
			}
			else
			{
				k=0;
				if (i!=0)
					if (img.bytes[j+(i-1)*img.Width_1]==255) k=1;
				if (i!=img.Height-1)
					if (img.bytes[j+(i+1)*img.Width_1]==255) k=1;
				if (j!=0)
					if (img.bytes[(j-1)+i*img.Width_1]==255) k=1;
				if (j!=img.Width-1)
				   if (img.bytes[(j+1)+i*img.Width_1]==255) k=1;
			}
			if ((ALLOCATE_WHITE&flags)==ALLOCATE_WHITE) continue;
			if (k==1) {
                img.bytes[j+i*img.Width_1]=128;
                //img.bytes[j*3+i*img.Width_1+1]=0;
                //img.bytes[j*3+i*img.Width_1+2]=0;
            }

		}
	}  

}


//      
IMG ReduceImage(IMG img,int param)
{
	IMG img1;
	img1.Width=img.Width/param;
	img1.Height=img.Height/param;
	img1.format=img.format;
	if (img.format==0)
	{
		if (img1.Width*3%4==0) img1.Width_1=img1.Width*3;
		else img1.Width_1=img1.Width*3+4-img1.Width*3%4; 

		img1.bytes=new byte[img1.Width_1*img1.Height]; 

		int i,j;

		for(i=0;i<img1.Height;i++)
			for(j=0;j<img1.Width;j++)
			{
				img1.bytes[i*img1.Width_1+j*3]=img.bytes[i*param*img.Width_1+j*param*3];
				img1.bytes[i*img1.Width_1+j*3+1]=img.bytes[i*param*img.Width_1+j*param*3+1];
				img1.bytes[i*img1.Width_1+j*3+2]=img.bytes[i*param*img.Width_1+j*param*3+2];
			}
	}
	if (img.format==1)
	{
		if (img1.Width%4==0) img1.Width_1=img1.Width;
		else img1.Width_1=img1.Width+4-img1.Width%4; 

		img1.bytes=new byte[img1.Width_1*img1.Height]; 

		int i,j;

		for(i=0;i<img1.Height;i++)
			for(j=0;j<img1.Width;j++)
			{
				img1.bytes[i*img1.Width_1+j]=img.bytes[i*param*img.Width_1+param*j];
			}
	}
	return img1;
}

IMG IncreaseImg(IMG img,int param)
{
	IMG img1;
	img1.Width=img.Width*param;
	img1.Height=img.Height*param;
	img1.format=img.format;
	if (img.format==0)
	{
		if (img1.Width*3%4==0) img1.Width_1=img1.Width*3;
		else img1.Width_1=img1.Width*3+4-img1.Width*3%4; 

		img1.bytes=new byte[img1.Width_1*img1.Height]; 

		int i,j;
		int i1,j1;

		for(i=0;i<img1.Height;i++)
			for(j=0;j<img1.Width;j++)
			{
				i1=i/param;
				j1=j/param;
				img1.bytes[i*img1.Width_1+j*3]=img.bytes[i1*img.Width_1+j1*3];
				img1.bytes[i*img1.Width_1+j*3+1]=img.bytes[i1*img.Width_1+j1*3+1];
				img1.bytes[i*img1.Width_1+j*3+2]=img.bytes[i1*img.Width_1+j1*3+2];
			}
	}
	if (img.format==1)
	{
		if (img1.Width%4==0) img1.Width_1=img1.Width;
		else img1.Width_1=img1.Width+4-img1.Width%4; 

		img1.bytes=new byte[img1.Width_1*img1.Height]; 

		int i,j;
		int i1,j1;

		for(i=0;i<img1.Height;i++)
			for(j=0;j<img1.Width;j++)
			{
				i1=i/param;
				j1=j/param;
				img1.bytes[i*img1.Width_1+j]=img.bytes[i1*img.Width_1+j1];
			}
	}
	return img1;
}

//     
int DrawRect(IMG img,RECT rect,byte c1,byte c2,byte c3)
{
	int i;
	for(i=rect.left;i<rect.right;i++)
	{		
		img.bytes[i*3+rect.top*img.Width_1]=c1;
		img.bytes[i*3+rect.top*img.Width_1+1]=c2;
		img.bytes[i*3+rect.top*img.Width_1+2]=c3;
		img.bytes[i*3+(rect.bottom-1)*img.Width_1]=c1;
		img.bytes[i*3+(rect.bottom-1)*img.Width_1+1]=c2;
		img.bytes[i*3+(rect.bottom-1)*img.Width_1+2]=c3;
	}
	for(i=rect.top;i<rect.bottom;i++)
	{		
		img.bytes[rect.left*3+i*img.Width_1]=c1;
		img.bytes[rect.left*3+i*img.Width_1+1]=c2;
		img.bytes[rect.left*3+i*img.Width_1+2]=c3;
		img.bytes[(rect.right-1)*3+i*img.Width_1]=c1;
		img.bytes[(rect.right-1)*3+i*img.Width_1+1]=c2;
		img.bytes[(rect.right-1)*3+i*img.Width_1+2]=c3;
	}
	return 0;
}

IMG Img24To8(IMG Img)
{
	IMG img1;

	img1.on=false;

	img1.Width=Img.Width;
	if (img1.Width%4==0) img1.Width_1=img1.Width;
    else img1.Width_1=img1.Width+4-img1.Width%4;  
	img1.Height=Img.Height;
	img1.bytes=new byte[img1.Width_1*img1.Height]; 
	img1.format=1;//8

	int i,j;
	double yyy;
	
	for(i=0;i<img1.Height;i++)
	for(j=0;j<img1.Width;j++)
	{	
		yyy=(double)(0.071* Img.bytes[j*3+i*Img.Width_1]+
				 0.707*Img.bytes[j*3+i*Img.Width_1+1]+
				 0.222*Img.bytes[j*3+i*Img.Width_1+2]);
		img1.bytes[j+i*img1.Width_1]=yyy;
	}

	img1.on=true;

	return img1;
}

IMG Img8To24(IMG Img)
{
	IMG img1;

	img1.on=false;

	img1.Width=Img.Width;
	if (img1.Width*3%4==0) img1.Width_1=img1.Width*3;
    else img1.Width_1=img1.Width*3+4-img1.Width*3%4;  
	img1.Height=Img.Height;
	img1.bytes=new byte[img1.Width_1*img1.Height]; 
	img1.format=0;//24

	int i,j;
	
	
	for(i=0;i<img1.Height;i++)
	for(j=0;j<img1.Width;j++)
	{			
		img1.bytes[j*3+i*img1.Width_1]=Img.bytes[j+i*Img.Width_1];
		img1.bytes[j*3+i*img1.Width_1+1]=Img.bytes[j+i*Img.Width_1];
		img1.bytes[j*3+i*img1.Width_1+2]=Img.bytes[j+i*Img.Width_1];
	}

	img1.on=true;

	return img1;
}

// 24 
void ClearImage(IMG img)
{
	int i,j;
	if (img.format==0)
		memset((void*)img.bytes,0,img.Width_1*img.Height);
}

void DrawPoint(IMG img,int x,int y,byte c1,byte c2,byte c3)
{
	if (img.format!=0) return;
	if (x<0 || y<0) return;
	img.bytes[x*3+y*img.Width_1]=c1;
	img.bytes[x*3+y*img.Width_1+1]=c2;
	img.bytes[x*3+y*img.Width_1+2]=c3;
}

void DrawFillRect(IMG Img,RECT Rect,byte c1,byte c2,byte c3)
{
	int i,j;
	if (Img.format!=0) return;
	for(i=Rect.top;i<=Rect.bottom;i++)
		for(j=Rect.left;j<=Rect.right;j++)
		{
			Img.bytes[j*3+i*Img.Width_1]=c1;
			Img.bytes[j*3+i*Img.Width_1+1]=c2;
			Img.bytes[j*3+i*Img.Width_1+2]=c3;

		}
}

void DeleteImg(IMG Img)
{
	if (Img.bytes!=NULL) delete Img.bytes;
}